#ifndef __DB_H__
#define __DB_H__

typedef struct {
	int lat0;
	int lon0;
	int lat1;
	int lon1;
	double lat;
	double lon;
	char parity;
	int id_source;
} cpr_info;

int db_init (sqlite3 *);
int db_delete_expired();
int db_delete_expired_log();
int db_update_icao(unsigned int *, adsb_data *);
int db_update_position(unsigned int*, double*, double*, adsb_data *);
int db_update_alt(unsigned int *, int *, int *, adsb_data *);
int db_update_speed_heading(unsigned int*, float*, float*, int *, adsb_data *);
int db_update_squawk (unsigned int *, unsigned int *, int *, adsb_data *);
int db_update_callsign (unsigned int *, char *, char *, adsb_data *);
int db_update_source_stat(adsb_data *);
int db_update_status(unsigned int *, unsigned char *, uint16_t *,
	float *, float *, unsigned char *, unsigned char *,
	unsigned char *, unsigned char *, unsigned char *, adsb_data *);
cpr_info db_update_cpr(unsigned int *, unsigned char *, int *, int *, int *);
int init_radar_range();

#endif
